#include <stdio.h>
#include "firecam.h"



int main(int argc, char** argv)
{
	int i;
	int cam_no = 0;
	int mode = 2;
	int framerate = 4;
	int turnoff = 0;
	int speed = 2;

	if (argc < 2)
	{
		printf("Usage:\ncamctrl init\ncamctrl <cam#> reset\ncamctrl <cam#> mode <m> rate <r> speed <s>\n\n");
		return 0;
	}
	
	firecam_open();
	firecam_num_cameras = 2;

	if (argc > 1 && !strcmp(argv[1], "init"))
	{
		firecam_init();
		firecam_enumerate();
		printf("Found %d cameras\n", firecam_num_cameras);
		return 0;
	}
	else if (argc > 1)
		cam_no = atoi(argv[1]);

	if (firecam_num_cameras < 1 || (cam_no+1) > firecam_num_cameras)
	{
		printf ("Invalid camera number\n");
		return 0;
	}
	
	i = 2;
	if (argc == 3 && !strcmp(argv[2], "off"))
	{
		turnoff = 1;
	}
	else if (argc == 3 && !strcmp(argv[2], "reset"))
	{
		firecam_reset(cam_no);
		return 0;
	}
	else while (i < argc)
	{
		if (!strcmp(argv[i], "mode"))
			mode = atoi(argv[++i]);
		else if (!strcmp(argv[i], "rate"))
			framerate = atoi(argv[++i]);
		else if (!strcmp(argv[i], "speed"))
			speed = atoi(argv[++i]);

		i++;
	}

	// Stop transmitting frame data
	firecam_stop_streaming(cam_no);
	
	if (turnoff != 1)
	{		
		// Set framerate
		firecam_set_rate(cam_no, framerate);
	
		// Set video mode
		firecam_set_mode(cam_no, mode);
		
		// Set video format
		firecam_set_format(cam_no, FORMAT_VGA);
		
		// Start streaming
		firecam_start_streaming(cam_no, speed);
	}
	
	return 0;
}
